//***************************************************************************
// _ǂ݂񑗐MSAORI
// saori_bouyomichan.h
// 
// By NightWork
//***************************************************************************

#include "csaori.h"
#include <deque>

#pragma once

#ifndef BOUYOMICHAN_SAORI_INCLUDED
#define BOUYOMICHAN_SAORI_INCLUDED

class CBouyomiChanData {
public:
	CBouyomiChanData(void) {
	}
	CBouyomiChanData(const std::string& t, const std::string& h, u_short p, short com, short sp, short to, short vol, short vo)
		: talk(t), host(h), port(p), command(com), speed(sp), tone(to), volume(vol), voice(vo) {
	}
	std::string talk;	//ǂݏグe
	std::string host;	//MzXg
	u_short port;		//M|[g
	short command;		//R}h
	short speed;		//x(-1FftHg, 50`300)
	short tone;		//(-1FftHg, 50`200)
	short volume;		//(-1FftHg, 0`100)
	short voice;		//(0FftHg, 1`8:AquesTalk, 10001` : SAPI5)
};

class CBouyomiChan : public CSAORI
{
private:
	SAORI_FUNC::CCriticalSection thread_lock;
	volatile int thread_active;
	std::deque<CBouyomiChanData> thread_queue;	//L[
	u_short thread_queue_max;			//L[̏l
	HANDLE thread_event;
	HANDLE thread_handle;

	//NGXg֐
	virtual void AddQueue(const CSAORIInput& in, CSAORIOutput& out);
	virtual void ClearQueue(const CSAORIInput& in, CSAORIOutput& out);
	virtual void SetQueueMax(const CSAORIInput& in, CSAORIOutput& out);


public:
	CBouyomiChan(void);
	~CBouyomiChan();

	void ThreadProc(void);

	virtual void exec(const CSAORIInput& in, CSAORIOutput& out);
	virtual bool unload();
	virtual bool load();
};

#endif BOUYOMICHAN_SAORI_INCLUDED

